/*******************************************************************************
 * FoxUIRelatedItemWidget generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxUIRelatedItemWidget extends FoxUIBaseWidget within GFxMoviePlayer
    native(UI)
    config(UI);

var const config float DisplayTime;
var const string WidgetSymbolName;
var const string WidgetContainerPath;
var const array<FoxTypes.EUnlockState> UnlockStateFilter;
var private transient float CurrentDisplayTime;
var private transient int SelectedIndex;
var private transient array<BaseStoreEntry> RelatedItemEntries;
var private transient bool bHidden;
var private transient bool bForceUpdate;

function Initialize(optional string ExtInterfaceClickFunc)
{
    Bind();
    SetString("extClickInterfaceFunc", ExtInterfaceClickFunc);
    //return;    
}

function Cleanup()
{
    as_hideTransition();
    super.Cleanup();
    //return;    
}

function SetItems(const array<BaseStoreEntry> RelatedItems, optional bool bTransition)
{
    RelatedItemEntries = RelatedItems;
    bForceUpdate = true;
    SelectedIndex = -1;
    // End:0x61
    if(RelatedItemEntries.Length > 0)
    {
        SetFloat("numOfItems", float(RelatedItemEntries.Length));
    }
    //return;    
}

event ShowNextItem(optional bool bShowPrev, optional int StartIndex)
{
    local int I, IndexIncrement;
    local bool bHasItem;

    StartIndex = -1;
    // End:0x15F
    if(RelatedItemEntries.Length > 0)
    {
        // End:0x4E
        if(bForceUpdate && ShowRelatedItem(SelectedIndex))
        {
            bHasItem = true;
        }
        // End:0x15F
        else
        {
            // End:0x88
            if((StartIndex != -1) && ShowRelatedItem(StartIndex))
            {
                bHasItem = true;
            }
            // End:0x15F
            else
            {
                // End:0xC4
                if((StartIndex < 0) || StartIndex >= RelatedItemEntries.Length)
                {
                    StartIndex = SelectedIndex;
                }
                IndexIncrement = ((bShowPrev) ? -1 : 1);
                I = 0;
                J0xEE:
                // End:0x15F [Loop If]
                if(I < RelatedItemEntries.Length)
                {
                    StartIndex = NextIndex(StartIndex, IndexIncrement);
                    // End:0x151
                    if(ShowRelatedItem(StartIndex))
                    {
                        bHasItem = true;
                        // [Explicit Break]
                        goto J0x15F;
                    }
                    ++ I;
                    // [Loop Continue]
                    goto J0xEE;
                }
            }
        }
    }
    // End:0x17B
    if(!bHasItem)
    {
        as_hideTransition();
    }
    // End:0x192
    else
    {
        // End:0x192
        if(bForceUpdate)
        {
            as_updateTransition();
        }
    }
    //return;    
}

protected function int NextIndex(int StartIndex, int IndexIncrement)
{
    StartIndex = (StartIndex + IndexIncrement) % RelatedItemEntries.Length;
    return ((StartIndex < 0) ? StartIndex + RelatedItemEntries.Length : StartIndex);
    //return ReturnValue;    
}

protected function bool ShowRelatedItem(int ItemIndex)
{
    // End:0x116
    if((ItemIndex >= 0) && ItemIndex < RelatedItemEntries.Length)
    {
        SelectedIndex = ItemIndex;
        CurrentDisplayTime = 0.0;
        as_addItemInfo(RelatedItemEntries[SelectedIndex]);
        SetString("extClickInterfaceArg", string(RelatedItemEntries[SelectedIndex].UnlockID));
        SetFloat("itemIndex", float(SelectedIndex));
        DynamicUI.ui_RunCommandGroup("CustomizationRelatedOffersTutorial");
        return true;
    }
    return false;
    //return ReturnValue;    
}

function AddLeftArrow(optional string ToolTip, optional string ExtInterfaceClickFunc)
{
    as_addLeftArrow(ToolTip, ExtInterfaceClickFunc);
    //return;    
}

function AddRightArrow(optional string ToolTip, optional string ExtInterfaceClickFunc)
{
    as_addRightArrow(ToolTip, ExtInterfaceClickFunc);
    //return;    
}

private final function as_updateTransition()
{
    ActionScriptVoid("updateTransition");
    bHidden = false;
    //return;    
}

private final function as_hideTransition()
{
    // End:0x35
    if(!bHidden)
    {
        ActionScriptVoid("hideTransition");
        bHidden = true;
    }
    //return;    
}

private final function as_addItemInfo(const BaseStoreEntry ItemEntry)
{
    ActionScriptVoid("setItemInfo");
    //return;    
}

private final function as_addLeftArrow(string ToolTip, string ExtInterfaceClickFunc)
{
    ActionScriptVoid("setupLeftArrow");
    //return;    
}

private final function as_addRightArrow(string ToolTip, string ExtInterfaceClickFunc)
{
    ActionScriptVoid("setupRightArrow");
    //return;    
}

defaultproperties
{
    DisplayTime=15.0
    WidgetSymbolName="w_armoryDeal"
    WidgetContainerPath="_root.stagePanelName"
    UnlockStateFilter(0)=251
    UnlockStateFilter(1)=41
}